#include <Windows.h>
#include <tchar.h>
#include <iostream>
#include <vector>
#include "sdk.h"
using namespace std;

std::vector<std::string> splitWithStl(const std::string &str, const std::string &pattern)
{
	std::vector<std::string> resVec;

	if ("" == str)
	{
		return resVec;
	}
	//ȡһ
	std::string strs = str + pattern;

	size_t pos = strs.find(pattern);
	size_t size = strs.size();

	while (pos != std::string::npos)
	{
		std::string x = strs.substr(0, pos);
		resVec.push_back(x);
		strs = strs.substr(pos + 1, size);
		pos = strs.find(pattern);
	}

	return resVec;
}

typedef BOOL (WINAPI* LOGIN)(const char* name, const char* password);
typedef BOOL (WINAPI* VPNCONNECT)(on_event_callback* callback, const char* province, const char* city);
typedef void (WINAPI* VPNDISCONNECT)();
typedef void (WINAPI* LOGOUT)();
typedef void (WINAPI* GETLASTERROR)(char* error, int nerr);

void myGetError(HMODULE hDll, char* szError, int nErr)
{
	GETLASTERROR pGetError = (GETLASTERROR)::GetProcAddress(hDll, "getlasterror");
	if (pGetError) {
		(*pGetError)(szError, nErr);
	}
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	HMODULE hDll = ::LoadLibrary("sdk.dll");
	char szError[1024] = { 0 };
	if (hDll) {
		LOGIN pLogin = (LOGIN)::GetProcAddress(hDll, "login");
		if (pLogin) {
			vector<string> vInput = splitWithStl(lpCmdLine, " ");
			BOOL b = (*pLogin)(vInput[0].c_str(), vInput[1].c_str());
			if (b) {
				VPNCONNECT pConnect = (VPNCONNECT)::GetProcAddress(hDll, "vpnconnect");
				if (pConnect) {
					b = (*pConnect)(NULL, NULL, NULL);
					if (!b) {
						myGetError(hDll, szError, 1024);
					}
					::MessageBoxA(NULL, b ? "ӳɹȷ󽫹رӡ" : szError, "ӽ", 0);
					VPNDISCONNECT pDisConnect = (VPNDISCONNECT)::GetProcAddress(hDll, "vpndisconnect");
					if (pDisConnect) {
						(*pDisConnect)();
					}
					LOGOUT pLogout = (LOGOUT)::GetProcAddress(hDll, "logout");
					if (pLogout) {
						(*pLogout)();
					}
				}
			}
			else {
				myGetError(hDll, szError, 1024);
				::MessageBoxA(NULL, szError, "¼ʧ", 0);
			}
		}
		::FreeLibrary(hDll);
	}

	return 0;
}